unit U_filinf;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Dialogs, FileCtrl, ExtCtrls, SysUtils,
  CALMIS16, CALFIL16,
  U_Vars, Delphi_u;

type
  TBtnRightDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Bevel1: TBevel;
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    Edit1: TEdit;
    GroupBox1: TGroupBox;
    CheckBoxRO: TCheckBox;
    CheckBoxHd: TCheckBox;
    CheckBoxSy: TCheckBox;
    CheckBoxX: TCheckBox;
    CheckBoxA: TCheckBox;
    CheckBoxSh: TCheckBox;
    CheckBoxTr: TCheckBox;
    CheckBoxIn: TCheckBox;
    LabelSize: TLabel;
    LabelOwner: TLabel;
    LabelName: TLabel;
    GroupBoxExtAttr: TGroupBox;
    CheckBoxIP: TCheckBox;
    CheckBoxRI: TCheckBox;
    CheckBoxDI: TCheckBox;
    CheckBoxCI: TCheckBox;
    CheckBoxFM: TCheckBox;
    CheckBoxDM: TCheckBox;
    CheckBoxIC: TCheckBox;
    CheckBoxFC: TCheckBox;
    CheckBoxDC: TCheckBox;
    CheckBoxCC: TCheckBox;
    RadioGroupNS: TRadioGroup;
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  BtnRightDlg: TBtnRightDlg;

implementation

{$R *.DFM}

procedure TBtnRightDlg.DirectoryListBox1Change(Sender: TObject);
begin
   FileListBox1.Directory :=  DirectoryListBox1.Directory;
end;

procedure TBtnRightDlg.FileListBox1Click(Sender: TObject);
VAR Server, MapPath, Path, FileName : String;
    Drive: nuint16;
    P: Word;
    iterHandle  : Array[1..9] of nuint8;
    info        : NW_FILE_INFO2;
    entryInfo   : NW_EXT_FILE_INFO;
    dirHandle   : NWDIR_HANDLE;
    driveScope  : pnuint16;
    dirPath     : pnstr8;
    tempHandle  : NWDIR_HANDLE;
    rightsMask  : nuint8;

    Procedure ShowFileInfo(info: NW_FILE_INFO2);
    begin
       CheckBoxRO.Checked   := (info.fileAttributes and FA_READ_ONLY)>0;
       CheckBoxHd.Checked   := (info.fileAttributes and FA_HIDDEN)>0;
       CheckBoxSy.Checked   := (info.fileAttributes and FA_SYSTEM)>0;
       CheckBoxX.Checked    := (info.fileAttributes and FA_EXECUTE_ONLY)>0;
       CheckBoxA.Checked    := (info.fileAttributes and FA_NEEDS_ARCHIVED)>0;
       CheckBoxSh.Checked   := (info.fileAttributes and FA_SHAREABLE)>0;

       CheckBoxTr.Checked   := (info.extendedFileAttributes and FA_TRANSACTIONAL)>0;
       CheckBoxIn.Checked   := (info.extendedFileAttributes and FA_INDEXED)>0;

       LabelSize.Caption    := 'Size:  '+ IntToStr(info.fileSize);
       LabelOwner.Caption   := 'Owner: '+ IntToHex(info.fileOwnerID, 8);
       LabelName.Caption    := 'Name:  '+ StrPas(info.fileName);
    end;

    Procedure ShowExtFileInfo(info: NW_EXT_FILE_INFO);
    begin
       CheckBoxIP.Checked := (info.attributes and A_IMMEDIATE_PURGE)>0;
       CheckBoxRI.Checked := (info.attributes and A_RENAME_INHIBIT)>0;
       CheckBoxDI.Checked := (info.attributes and A_DELETE_INHIBIT)>0;
       CheckBoxCI.Checked := (info.attributes and A_COPY_INHIBIT)>0;
       CheckBoxFM.Checked := (info.attributes and A_FILE_MIGRATED)>0;
       CheckBoxDM.Checked := (info.attributes and A_DONT_MIGRATE)>0;
       CheckBoxIC.Checked := (info.attributes and A_IMMEDIATE_COMPRESS)>0;
       CheckBoxFC.Checked := (info.attributes and A_FILE_COMPRESSED)>0;
       CheckBoxDC.Checked := (info.attributes and A_DONT_COMPRESS)>0;
       CheckBoxCC.Checked := (info.attributes and A_CANT_COMPRESS)>0;
       RadioGroupNS.ItemIndex := info.nameSpace;

    end;

begin
   Server := ''; MapPath := ''; Path := '';
   fileName := UpperString(Edit1.Text)+#0;   if Pos('*', fileName)>0 then exit;

   P := Pos('\\', DriveComboBox1.Text);  { network path ? }
   if (P>0) then begin
      Server      := Copy(DriveComboBox1.Text, 6, 255);
      P           := Pos('\', Server);
      Drive       := Succ(BYTE(UpCase(DriveComboBox1.Text[1])) - BYTE('A'));
      if (p>0) then Server   := Copy(Server, 1,   P-1);
      end;

   cCode       := NWGetDriveInformation(Drive, 0, connHandle, dirHandle, @driveScope, @MapPath[1]);

   MapPath[0]  := Char(StrLen(@MapPath[1]));
   Path        := StrPas(@MapPath[1]) + '\' + fileName;

   FillChar(iterHandle, sizeOf(iterHandle), $FF);
   cCode       := NWIntScanFileInformation2(connHandle, 0, @Path[1],
                     faReadOnly+faSysFile+faHidden+faArchive, @iterHandle, info, 0);

   if (cCode=0) then ShowFileInfo(info);

   FillChar(iterHandle, sizeOf(iterHandle), $FF);
   cCode := NWIntScanExtendedInfo(connHandle, dirHandle, faReadOnly+faSysFile+faHidden+faArchive,
               @iterHandle, @fileName[1], entryInfo, 0);
   if (cCode=0) then ShowExtFileInfo(entryInfo);
end;

end.
